<template>
    <div class="add-item">
        <h1>CREATE NEW PRODUCT:</h1>
        <div v-if="errors.length">
            <b>Please fix errors:</b>
            <ul>
                <li v-for="error in errors" :key="error">{{ error }}</li>
            </ul>
        </div>
        <form action="" @submit.prevent="submitForm">
            <div class="input-wrapper">
                <label>
                    Product name:<br>
                    <input type="text" id="name" v-model="name">
                </label>
            </div>
            <div class="input-wrapper">
                <label>
                    <input type="checkbox" id="isAvailable" v-model="isAvailable">
                    is available?:
                </label>
            </div>
            <div class="input-wrapper">
                <label>
                    Category:<br>
                    <select v-model="category">
                        <option disabled value="">Select category</option>
                        <option
                                v-for="category in categories"
                                :key="category"
                                :value="category"
                        >{{category}}</option>
                    </select>
                </label>
            </div>
            <div class="input-wrapper">
                <label>
                    Color:<br>
                    <select v-model="color">
                        <option disabled value="">Select color</option>
                        <option
                                v-for="color in colors"
                                :key="color"
                                :value="color"
                        >{{color}}</option>
                    </select>
                </label>
            </div>
            <div class="input-wrapper">
                <label>
                    Product Price:<br>
                    <input type="number" min="0.01" step="any" id="price" v-model="price">
                    {{currencySymbol}}
                </label>
            </div>
            <div class="input-wrapper">
                <label>
                    Description:<br>
                    <textarea v-model="description" cols="100" rows="10"></textarea>
                </label>
            </div>
            <div class="input-wrapper">
                <input class="button" type="submit" value="Add Product">
            </div>
        </form>
    </div>
</template>

<script>
import uuid from "uuid/v1";
import { mapState, mapActions } from "vuex";

export default {
  name: "CreateItem",
  data() {
    return {
      errors: [],
      name: "",
      category: null,
      price: null,
      currencySymbol: "$",
      image: "http://placehold.it/150x150",
      color: null,
      description: "",
      isAvailable: true
    };
  },

  computed: {
    ...mapState({
      categories: state => state.catalog.categories,
      colors: state => state.catalog.colors
    })
  },

  methods: {
    ...mapActions("catalog", ["addItem"]),

    submitForm(e) {
      const validated = this.validateForm();
      if (validated) {
        const newItem = {
          ...this.$data,
          id: uuid()
        };

        delete newItem.errors;

        this.addItem(newItem);
        e.target.reset();
        window.alert(`Product "${newItem.name}" was added to catalog`);
      }
    },

    validateForm() {
      if (this.name && this.category && this.color && this.price) {
        return true;
      }

      this.errors = [];

      if (!this.name) {
        this.errors.push("Name required!");
      }
      if (!this.category) {
        this.errors.push("Category required!");
      }
      if (!this.color) {
        this.errors.push("Color required!");
      }
      if (!this.price) {
        this.errors.push("Price required!");
      }
    }
  }
};
</script>

<style>
.add-item {
  width: 50%;
  padding: 20px;
}
.input-wrapper {
  margin: 20px 0;
  > * {
    width: 100%;
  }
}
</style>
